Description

The new Media element in 4.7 doesn't work at all with YouTube video's. The Media content elements from 4.6 were silently converted
and the old URL was set in the 'Path or URL to fallback video source (Flash or QuickTime)' field.
Unfortunately the frontend only displays a media player or an error message (depending on the rendering setting).

I tried the short URL, long (old) URL, URL from the YouTube embed code, but none of these are recognized.

Besides this, the new flexform is very confusing and not intuitive. It lacks CSH texts.

Related issues:
related to Core - Bug # 53097: MEDIA / renderType / impossible to use custom ... New 2013-10-24

Associated revisions
Revision fe129bbb - 2012-04-11 20:28 - Steffen Ritter

[BUGFIX] Media Element does not play videos with own player anymore

Since the rewrite to FlowPlayer and the additions for accessibility
the MEDIA Content Element is not capable anymore, to play videos which
ship their own player.

This especially is the case for Videos which are from YouTube, Vimeo
and other similiar platforms. Looking at the implementation it seems,
that the detection of own players has been removed (accidentilly).

Rebuild this detection to make external video platform links work again.

Change-Id: I963a74aa3e1ab6d2de95ade903470be71af5c2d4
Fixes: #33357
Releases: 6.0, 4.7
Reviewed-on: http://review.typo3.org/10259
Reviewed-by: Susanne Moog
Tested-by: Susanne Moog
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision 40341d7f - 2012-04-11 20:54 - Steffen Ritter
[BUGFIX] Media Element does not play videos with own player anymore

Since the rewrite to FlowPlayer and the additions for accessibility
the MEDIA Content Element is not capable anymore, to play videos which
ship their own player.

This especially is the case for Videos which are from YouTube, Vimeo
and other similiar platforms. Looking at the implementation it seems,
that the detection of own players has been removed (accidentilly).

Rebuild this detection to make external video platform links work again.

Change-Id: Ifdc579b12794e09c51bd3ddad0290c2cc9470760
Fixes: #33357
Releases: 6.0, 4.7
Reviewed-on: http://review.typo3.org/10272
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History
#1 - 2012-01-23 06:47 - Jigal van Hemert

Debugging shows that the processing of the URL is correct (only the new url shortener of YouTube isn't supported but that is another (simple) issue).

The problem seems that:

    1. the HTML video tag does not support YouTube videos
    2. FlowPlayer doesn't support YouTube videos out of the box (there is some documentation on various sites on how make some code in flowplayer
to support YouTube)

The latter probably means that this has to be done for all the video sites which are currently supported by the mediaWizardCoreProvider in the core.

#2 - 2012-01-23 09:56 - Stanislas Rolland

The YouTube url does not refer to any video media at all. It is a link to a page. If you want you can embed it in an iframe.

#3 - 2012-01-23 11:16 - Jigal van Hemert

It is true that a YouTube (or Vimeo) URL does not refer to a media file. However, it worked in previous versions and the URLs are processed correctly
by the code in the core for processing the media element. There are even functions in the mediaWizardCoreProvider for handling URLs from
YouTube, Vimeo and other video sites.

Sites which have YouTube (and other) videos in their page content will after upgrading to 4.7 be faced with broken videos.

In the light of the subtitle of 4.7 "standards and accessibility" an iframe is of course out of the question!

This new media element is for site owners and editors a major step back. If such a media element has to be introduced, then it should be a new type
of content element and not silently replacing an existing element (and breaking it in the process).
#4 - 2012-01-23 21:49 - Ernesto Baschny
- File media-url-in-45-46.png added
- File media-url-in-47.png added

Some more input (from the thread in the mailing list):

What was called "Path or URL" in the flexform in 4.5 and 4.6 is now called "Path or URL to fallback video source (Flash or QuickTime)". Both stored in
the same FF field (at least it won't be dropped during the upgrade): sDEF.lDEF.mmFile:

4.5 and 4.6 flexform

4.7 flexform:

The previous idea (4.5 - 4.6) was that the editor could enter "anything" in this field (be it an URL he copied from Youtube or a reference to a local file),
the "media wizard" would find the correct code for it.

I am not 100% satisfied with how it works in 4.5 (it should do more "magic" like not trying to use the flowplayer if the URL is supported by some media
wizard provider - e.g. Youtube), but this is yet another topic.

Some rought idea on how to solve it:

Rephrase "Path or URL to fallback video source (Flash or QuickTime)" into: "Path or URL (fallback video source or original video URL)" and have the
"media wizard provider" be called to check if this URL can be handled before doing the "new stuff":
$mediaWizard = tslib_mediaWizardManager::getValidMediaWizardProvider($url);
if ($mediaWizard !== NULL && $mediaWizard->canHandle($url)) {
    // then do the old-style MEDIA rendering...
}

It's a bit a shame that the new implementation hasn't really looked on how the current methods work in order to consider it from start.

#5 - 2012-03-05 17:56 - Steffen Ritter
- Target version changed from 4.7.0-beta1 to 4.7.0-beta2

#6 - 2012-03-13 14:42 - Steffen Ritter
- Target version changed from 4.7.0-beta2 to 4.7.0-beta3

#7 - 2012-03-31 18:39 - Steffen Ritter
- Assigned To set to Steffen Ritter
- Target version changed from 4.7.0-beta3 to 4.7.0-RC1

#8 - 2012-03-31 20:36 - Steffen Ritter
- Status changed from New to Accepted

#9 - 2012-03-31 20:42 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch TYPO3_4-7 has been pushed to the review server.
It is available at http://review.typo3.org/10110

#10 - 2012-04-11 17:12 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10259

#11 - 2012-04-11 17:59 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10259

#12 - 2012-04-11 20:54 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-7 has been pushed to the review server.
It is available at http://review.typo3.org/10272

#13 - 2012-04-11 23:28 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10304

#14 - 2012-04-12 02:30 - Steffen Ritter
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:40341d7f47a6daaf25ac38c988f823089ce02570.

#15 - 2012-05-25 11:41 - Andreas Dolleschal

this fix does not solve the problem with youtube videos. youtube videos simply will not be shown. tested with 4.7.1

#16 - 2012-06-04 15:53 - Lorenz Ulrich

I can confirm this.

#17 - 2012-07-25 17:45 - Felix Nagel

In TYOP3 4.7.1 I'm not able to reproduce this. Standard YouTube links (for example http://www.youtube.com/watch?v=KxOhc-dfEDY) work like a
charm (even its still the old embedded code).

#18 - 2012-07-31 10:09 - Christian Hennecke

I can confirm that it does NOT work in TYPO3 4.7.2. I also agree that the flexform is non-intuitive.

#19 - 2012-07-31 10:24 - Felix Nagel

Your're right, Christian. I've just tested this again and can confirm that it works on 4.7.1 and does NOT work on 4.7.2.

#20 - 2013-07-10 13:34 - daniel no-lastname-given

It doesn't work in TYPO3 6.1.1 either for mobile phones and ipads. This Bug still exists.

#21 - 2014-05-21 11:07 - Paul A. Auwehla

Bug was off at least in typo3 6.1.7
Bug is back again in 6.2.2: 
No external video URL with content element Media.

See bug #58985 and #58986.
Is there any workaround?
Some typoscript for example?

Files
media-url-in-45-46.png 11.9 kB 2012-01-23 Ernesto Baschny
media-url-in-47.png 15.5 kB 2012-01-23 Ernesto Baschny
